<?php
/**
 * CustomerForReplace
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CustomersClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Customers
 *
 * Управление клиентами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CustomersClient\Dto;

use \ArrayAccess;
use \Ensi\CustomersClient\ObjectSerializer;

/**
 * CustomerForReplace Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CustomersClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CustomerForReplace implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CustomerForReplace';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'user_id' => 'int',
        'status_id' => 'int',
        'manager_id' => 'int',
        'yandex_metric_id' => 'string',
        'google_analytics_id' => 'string',
        'active' => 'bool',
        'email' => 'string',
        'phone' => 'string',
        'last_name' => 'string',
        'first_name' => 'string',
        'middle_name' => 'string',
        'gender' => 'int',
        'create_by_admin' => 'bool',
        'city' => 'string',
        'birthday' => '\DateTime',
        'last_visit_date' => '\DateTime',
        'comment_status' => 'string',
        'timezone' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'user_id' => null,
        'status_id' => null,
        'manager_id' => null,
        'yandex_metric_id' => null,
        'google_analytics_id' => null,
        'active' => null,
        'email' => null,
        'phone' => null,
        'last_name' => null,
        'first_name' => null,
        'middle_name' => null,
        'gender' => null,
        'create_by_admin' => null,
        'city' => null,
        'birthday' => 'date',
        'last_visit_date' => 'date-time',
        'comment_status' => null,
        'timezone' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'user_id' => true,
        'status_id' => true,
        'manager_id' => true,
        'yandex_metric_id' => true,
        'google_analytics_id' => true,
        'active' => false,
        'email' => false,
        'phone' => false,
        'last_name' => true,
        'first_name' => true,
        'middle_name' => true,
        'gender' => true,
        'create_by_admin' => false,
        'city' => true,
        'birthday' => true,
        'last_visit_date' => true,
        'comment_status' => true,
        'timezone' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'user_id' => 'user_id',
        'status_id' => 'status_id',
        'manager_id' => 'manager_id',
        'yandex_metric_id' => 'yandex_metric_id',
        'google_analytics_id' => 'google_analytics_id',
        'active' => 'active',
        'email' => 'email',
        'phone' => 'phone',
        'last_name' => 'last_name',
        'first_name' => 'first_name',
        'middle_name' => 'middle_name',
        'gender' => 'gender',
        'create_by_admin' => 'create_by_admin',
        'city' => 'city',
        'birthday' => 'birthday',
        'last_visit_date' => 'last_visit_date',
        'comment_status' => 'comment_status',
        'timezone' => 'timezone'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'user_id' => 'setUserId',
        'status_id' => 'setStatusId',
        'manager_id' => 'setManagerId',
        'yandex_metric_id' => 'setYandexMetricId',
        'google_analytics_id' => 'setGoogleAnalyticsId',
        'active' => 'setActive',
        'email' => 'setEmail',
        'phone' => 'setPhone',
        'last_name' => 'setLastName',
        'first_name' => 'setFirstName',
        'middle_name' => 'setMiddleName',
        'gender' => 'setGender',
        'create_by_admin' => 'setCreateByAdmin',
        'city' => 'setCity',
        'birthday' => 'setBirthday',
        'last_visit_date' => 'setLastVisitDate',
        'comment_status' => 'setCommentStatus',
        'timezone' => 'setTimezone'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'user_id' => 'getUserId',
        'status_id' => 'getStatusId',
        'manager_id' => 'getManagerId',
        'yandex_metric_id' => 'getYandexMetricId',
        'google_analytics_id' => 'getGoogleAnalyticsId',
        'active' => 'getActive',
        'email' => 'getEmail',
        'phone' => 'getPhone',
        'last_name' => 'getLastName',
        'first_name' => 'getFirstName',
        'middle_name' => 'getMiddleName',
        'gender' => 'getGender',
        'create_by_admin' => 'getCreateByAdmin',
        'city' => 'getCity',
        'birthday' => 'getBirthday',
        'last_visit_date' => 'getLastVisitDate',
        'comment_status' => 'getCommentStatus',
        'timezone' => 'getTimezone'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('user_id', $data, null);
        $this->setIfExists('status_id', $data, null);
        $this->setIfExists('manager_id', $data, null);
        $this->setIfExists('yandex_metric_id', $data, null);
        $this->setIfExists('google_analytics_id', $data, null);
        $this->setIfExists('active', $data, null);
        $this->setIfExists('email', $data, null);
        $this->setIfExists('phone', $data, null);
        $this->setIfExists('last_name', $data, null);
        $this->setIfExists('first_name', $data, null);
        $this->setIfExists('middle_name', $data, null);
        $this->setIfExists('gender', $data, null);
        $this->setIfExists('create_by_admin', $data, null);
        $this->setIfExists('city', $data, null);
        $this->setIfExists('birthday', $data, null);
        $this->setIfExists('last_visit_date', $data, null);
        $this->setIfExists('comment_status', $data, null);
        $this->setIfExists('timezone', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets user_id
     *
     * @return int|null
     */
    public function getUserId()
    {
        return $this->container['user_id'];
    }

    /**
     * Sets user_id
     *
     * @param int|null $user_id Идентификатор пользователя
     *
     * @return $this
     */
    public function setUserId($user_id)
    {

        if (is_null($user_id)) {
            array_push($this->openAPINullablesSetToNull, 'user_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('user_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['user_id'] = $user_id;

        return $this;
    }

    /**
     * Gets status_id
     *
     * @return int|null
     */
    public function getStatusId()
    {
        return $this->container['status_id'];
    }

    /**
     * Sets status_id
     *
     * @param int|null $status_id Идентификатор статуса пользователя
     *
     * @return $this
     */
    public function setStatusId($status_id)
    {

        if (is_null($status_id)) {
            array_push($this->openAPINullablesSetToNull, 'status_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('status_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['status_id'] = $status_id;

        return $this;
    }

    /**
     * Gets manager_id
     *
     * @return int|null
     */
    public function getManagerId()
    {
        return $this->container['manager_id'];
    }

    /**
     * Sets manager_id
     *
     * @param int|null $manager_id Идентификатор менеджера
     *
     * @return $this
     */
    public function setManagerId($manager_id)
    {

        if (is_null($manager_id)) {
            array_push($this->openAPINullablesSetToNull, 'manager_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('manager_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['manager_id'] = $manager_id;

        return $this;
    }

    /**
     * Gets yandex_metric_id
     *
     * @return string|null
     */
    public function getYandexMetricId()
    {
        return $this->container['yandex_metric_id'];
    }

    /**
     * Sets yandex_metric_id
     *
     * @param string|null $yandex_metric_id Идентификатор пользователя в YandexMetric
     *
     * @return $this
     */
    public function setYandexMetricId($yandex_metric_id)
    {

        if (is_null($yandex_metric_id)) {
            array_push($this->openAPINullablesSetToNull, 'yandex_metric_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('yandex_metric_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['yandex_metric_id'] = $yandex_metric_id;

        return $this;
    }

    /**
     * Gets google_analytics_id
     *
     * @return string|null
     */
    public function getGoogleAnalyticsId()
    {
        return $this->container['google_analytics_id'];
    }

    /**
     * Sets google_analytics_id
     *
     * @param string|null $google_analytics_id Идентификатор пользователя в GoogleAnalytics
     *
     * @return $this
     */
    public function setGoogleAnalyticsId($google_analytics_id)
    {

        if (is_null($google_analytics_id)) {
            array_push($this->openAPINullablesSetToNull, 'google_analytics_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('google_analytics_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['google_analytics_id'] = $google_analytics_id;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active Активность пользователя
     *
     * @return $this
     */
    public function setActive($active)
    {


        /*if (is_null($active)) {
            throw new \InvalidArgumentException('non-nullable active cannot be null');
        }*/
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email Email
     *
     * @return $this
     */
    public function setEmail($email)
    {


        /*if (is_null($email)) {
            throw new \InvalidArgumentException('non-nullable email cannot be null');
        }*/
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets phone
     *
     * @return string|null
     */
    public function getPhone()
    {
        return $this->container['phone'];
    }

    /**
     * Sets phone
     *
     * @param string|null $phone Телефон
     *
     * @return $this
     */
    public function setPhone($phone)
    {


        /*if (is_null($phone)) {
            throw new \InvalidArgumentException('non-nullable phone cannot be null');
        }*/
        $this->container['phone'] = $phone;

        return $this;
    }

    /**
     * Gets last_name
     *
     * @return string|null
     */
    public function getLastName()
    {
        return $this->container['last_name'];
    }

    /**
     * Sets last_name
     *
     * @param string|null $last_name Фамилия
     *
     * @return $this
     */
    public function setLastName($last_name)
    {

        if (is_null($last_name)) {
            array_push($this->openAPINullablesSetToNull, 'last_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('last_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['last_name'] = $last_name;

        return $this;
    }

    /**
     * Gets first_name
     *
     * @return string|null
     */
    public function getFirstName()
    {
        return $this->container['first_name'];
    }

    /**
     * Sets first_name
     *
     * @param string|null $first_name Имя
     *
     * @return $this
     */
    public function setFirstName($first_name)
    {

        if (is_null($first_name)) {
            array_push($this->openAPINullablesSetToNull, 'first_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('first_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['first_name'] = $first_name;

        return $this;
    }

    /**
     * Gets middle_name
     *
     * @return string|null
     */
    public function getMiddleName()
    {
        return $this->container['middle_name'];
    }

    /**
     * Sets middle_name
     *
     * @param string|null $middle_name Отчество
     *
     * @return $this
     */
    public function setMiddleName($middle_name)
    {

        if (is_null($middle_name)) {
            array_push($this->openAPINullablesSetToNull, 'middle_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('middle_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['middle_name'] = $middle_name;

        return $this;
    }

    /**
     * Gets gender
     *
     * @return int|null
     */
    public function getGender()
    {
        return $this->container['gender'];
    }

    /**
     * Sets gender
     *
     * @param int|null $gender Пол из CustomerGenderEnum
     *
     * @return $this
     */
    public function setGender($gender)
    {

        if (is_null($gender)) {
            array_push($this->openAPINullablesSetToNull, 'gender');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('gender', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['gender'] = $gender;

        return $this;
    }

    /**
     * Gets create_by_admin
     *
     * @return bool|null
     */
    public function getCreateByAdmin()
    {
        return $this->container['create_by_admin'];
    }

    /**
     * Sets create_by_admin
     *
     * @param bool|null $create_by_admin Пользователь создан администратором
     *
     * @return $this
     */
    public function setCreateByAdmin($create_by_admin)
    {


        /*if (is_null($create_by_admin)) {
            throw new \InvalidArgumentException('non-nullable create_by_admin cannot be null');
        }*/
        $this->container['create_by_admin'] = $create_by_admin;

        return $this;
    }

    /**
     * Gets city
     *
     * @return string|null
     */
    public function getCity()
    {
        return $this->container['city'];
    }

    /**
     * Sets city
     *
     * @param string|null $city Город клиента
     *
     * @return $this
     */
    public function setCity($city)
    {

        if (is_null($city)) {
            array_push($this->openAPINullablesSetToNull, 'city');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('city', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['city'] = $city;

        return $this;
    }

    /**
     * Gets birthday
     *
     * @return \DateTime|null
     */
    public function getBirthday()
    {
        return $this->container['birthday'];
    }

    /**
     * Sets birthday
     *
     * @param \DateTime|null $birthday День рождения
     *
     * @return $this
     */
    public function setBirthday($birthday)
    {

        if (is_null($birthday)) {
            array_push($this->openAPINullablesSetToNull, 'birthday');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('birthday', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['birthday'] = $birthday;

        return $this;
    }

    /**
     * Gets last_visit_date
     *
     * @return \DateTime|null
     */
    public function getLastVisitDate()
    {
        return $this->container['last_visit_date'];
    }

    /**
     * Sets last_visit_date
     *
     * @param \DateTime|null $last_visit_date Дата последней авторизации
     *
     * @return $this
     */
    public function setLastVisitDate($last_visit_date)
    {

        if (is_null($last_visit_date)) {
            array_push($this->openAPINullablesSetToNull, 'last_visit_date');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('last_visit_date', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['last_visit_date'] = $last_visit_date;

        return $this;
    }

    /**
     * Gets comment_status
     *
     * @return string|null
     */
    public function getCommentStatus()
    {
        return $this->container['comment_status'];
    }

    /**
     * Sets comment_status
     *
     * @param string|null $comment_status Коментарий к статусу клиента
     *
     * @return $this
     */
    public function setCommentStatus($comment_status)
    {

        if (is_null($comment_status)) {
            array_push($this->openAPINullablesSetToNull, 'comment_status');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('comment_status', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['comment_status'] = $comment_status;

        return $this;
    }

    /**
     * Gets timezone
     *
     * @return string|null
     */
    public function getTimezone()
    {
        return $this->container['timezone'];
    }

    /**
     * Sets timezone
     *
     * @param string|null $timezone Временная зона
     *
     * @return $this
     */
    public function setTimezone($timezone)
    {


        /*if (is_null($timezone)) {
            throw new \InvalidArgumentException('non-nullable timezone cannot be null');
        }*/
        $this->container['timezone'] = $timezone;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


